<?php


namespace OrganizationsManagement\Controller;

use OrganizationsManagement\Traits\TResponse;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\DataSet;
use OrganizationsManagement\Util\Utilities;
use OrganizationsManagement\Util\InstanceProvider;
use \OrganizationsManagement\Service\DbVersion as DbVersionService;

class DbVersion
{

    use TResponse;

    private $dbVersionService;

    public function __construct(DbVersionService $dbVersionService){
        $this->dbVersionService = $dbVersionService;
    }

    public function findLastDbVersion(DTO\Request $request, DTO\Response $response){
        try{
            $nrorg = $request->getParameter('NRORG');
            $data = $this->dbVersionService->findLastDbVersion($nrorg);
            $this->sendResponse($data, 200);
        }catch(Exception $ex){
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
