<?php

namespace OrganizationsManagement\Repository;

use Doctrine\ORM\EntityManager;
use Teknisa\Model\Traits\TQuery;

class CollectionErrors
{
    use TQuery;
    /**
     * @var EntityManager
     */
    private $entityManager;

    /**
     * @param EntityManager $entityManager
     */
    public function __construct(EntityManager $entityManager)
    {
        $this->entityManager = $entityManager;
    }

    public function getCollectionErros()
    {
        $query = <<<SQL
    SELECT ECL.ID, TO_CHAR(ECL.DTULTCOLETASUC, 'DD/MM/YYYY') AS DTULTCOLETASUC, ECL.NRORG_ID, ORG.NMRAZSOCIALORG, ECL.ERRO_COLETA,
           ORG.NRORG || ' - ' || ORG.NMORGANIZACAO AS NMORGANIZACAO,
           ECL.CDTPMEDIDASERV, TPM.DSTPMEDIDASERV, ECL.CDSERVORCA, SEO.NMSERVORCA,
           ECL.PRODUCT_ID, PRO.NAME AS PRODUCT_NAME, ECL.NRSEQCONTRATO, CTR.NRCONTRATOFCT,
           TO_CHAR(ECL.DTINCLUSAO, 'DD/MM/YYYY HH24:MI:SS') AS DTINCLUSAO,
           TO_CHAR(ECL.DTINCLUSAO, 'DD/MM/YYYY') AS DIACOLETA,
           TO_CHAR(ECL.DTINICOMPET, 'DD/MM/YYYY') AS DTINICOMPET,
           TO_CHAR(ECL.DTFINCOMPET, 'DD/MM/YYYY') AS DTFINCOMPET, SCRIPT_COUNT, SCRIPT_LOG, IDTPSCRIPT, IDTPERRO, DSSTRINGCONEXAO, IDUTWALLET,
           IDCOLETOR, IDTPCOLETA , SCRIPT_COUNT_PHP, SCRIPT_LOG_PHP, SCRIPT_COUNT_SQL, SCRIPT_LOG_SQL
      FROM ERROS_COLETA ECL
      JOIN ORGANIZACAO ORG        ON ORG.NRORG = ECL.NRORG_ID
      JOIN FCT_TIPOMEDIDASERV TPM ON TPM.CDTPMEDIDASERV = ECL.CDTPMEDIDASERV
      JOIN FCT_CONTRATO CTR ON CTR.NRSEQCONTRATO = ECL.NRSEQCONTRATO
 LEFT JOIN FCT_SERVICOORCA SEO    ON SEO.CDSERVORCA = ECL.CDSERVORCA
 LEFT JOIN PRODUCT PRO            ON PRO.ID = ECL.PRODUCT_ID
  ORDER BY DTINCLUSAO DESC
SQL;

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $query);
    }
}
